%% Chapter on QC and processing

\chapter{Simple in-class options}
\label{chap:easyButton}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Background} %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

The ways we have covered so far,
focusing on R and the Linux command-line,
are the most robust way to do RNAseq analysis,
especially for research purposes.
%
However,
if you have a four-hour lab available to cover ``bioinformatics''
for freshman,
spending your time teaching them R and Linux may not be fruitful.
%
(Aside: If you have longer,
and your goal it to train students to actually do the analysis,
it is almost certainly worth your time.)
%
In these cases,
you may wish to opt for a simpler approach,
with click-able menus,
and fewer places for students to wander off-track.
%
In this chapter,
I will present a (very) brief introduction to a few of these options.
%
Each lowers the bar to entry into bioinformatics,
but generally at the cost of 
in-depth understanding,
flexibility,
power, and/or
expense.


Many of these tools also ease the entry to research questions as well.
%
However, while they will get you started,
they are rarely enough to finish an analysis,
and you will likely (eventually) find yourself pulled back
to R and the command line.
%





\begin{figure}[h]
\begin{center}
\includegraphics[width=.3\textwidth]{../images/easyButton_bw}
\caption{Staples easy button}
\end{center}
\end{figure}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Chapter goals} %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{itemize}
 \item Introduce simple alternatives
 \item Understand the utility and disadvantages of various trade-offs
 \item Explore ways to expose students to bioinformatics
\end{itemize}

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% \section{Vision and Change Competencies addressed}  %%%%%%
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% \begin{itemize}
%  \item Ability to communicate and collaborate with other disciplines
% \end{itemize}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Galaxy} %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


Galaxy is one of several implementations of a ``workflow system.''
%
These systems generally include a graphical user interface that
makes it easier for those new to bioinformatic analyses
(such as students in a class) to begin making progress.
%
The available programs are limited,
and default parameters are often set to ease the load on the computers.
%
This makes completing tasks easier,
but leaves many decisions out of the investigator or students' hands.
%
The instructions here are specifically for Galaxy,
but common sense and Google will allow you to use these as a guide to enter other systems as well.
%
Because I have more (though still limited) experience with Galaxy,
this section will be much more thorough than the others
in this chapter.



\subsection{Get access}

There are many implementations of Galaxy that are run by various groups
across the country (GCAT-SEEK may be getting one).
%
However, the process for signing up will be similar no matter where you are joining.
%
% Merge these two short pps
Google for ``galaxy'' and look for the Penn State implementation
(the url is \href{https://usegalaxy.org/}{usegalaxy.org},
but Google and one-click will be faster than remembering that).
%
You may wish to bookmark this page to make it easier to get back to it.
%
Click on ``user'' at the top,
and select ``Register.''
%
Follow the on-screen instructions to get an account.
%
Make sure to remember or save the password you select.
%
% Merge these two short pps
Each time you want to sign on,
go to the Galaxy main-page.
%
Click ``User'' at the top,
and select ``login'',
and your saved sessions should be available to you.


\subsection{Load data}

There are several ways to load data into Galaxy.
%
Here, we will focus on loading data directly from your computer.
%
However, it is also possible to load in data from other sites on the internet
(such as UCSC, BioMart, and several organism specific repositories).
%
All of these methods start with clicking ``Get Data'' at the
top of the left-hand options from any page in Galaxy,
then selecting one of the options.


The simplest approach to get data into Galaxy is to load it through the browser.
%
After selecting ``Get Data,'' click ``Upload File.''
%
Leave the top set to ``Auto-detect'' to make sure it reads your data appropriately.
%
Browse for your file under ``Choose File'' and click ``Execute.''
%
The file should upload and become available in your ``History'' panel
on the right-hand side of the screen.
%
However, this will likely fail for large files.


There are two alternatives to upload larger files.
%
First, you can load the files online somewhere
(e.g. Dropbox, Google Drive, etc.)
where the file can be downloaded directly.
%
Simply put the file on your sharing site of choice,
set the sharing settings to get a url,
then paste the url into the box labeled ``URL'' and click ``Execute.''
%
You can also upload the files using ftp.
%
Connect to the ftp server listed on the page (it may vary),
sign in using your Galaxy credentials,
and load the file.
%
Any ftp program will work for this.
%
The file(s) will then be listed on the page -- click
the box next to the files you want to load and click ``Execute.``


\subsection{Install programs}

Do nothing.
%
One of the benefits of using this kind of platform is that you (usually)
don't have to install programs at all.
%
Everything is already done for you.
%
However, this also means that it is very difficult to add programs,
if what you want to use is not present.
%
Further, each instance of Galaxy has a slightly different suite of tools,
so it may be worth looking at other options
(e.g., Indiana University has a Galaxy instance with a few more tools than
the main instance).
%
To run the program you are interested in,
find it in the list on the left hand side of the screen,
select it,
and follow the on-screen prompts.

\subsection{Where to go for help}

Galaxy is set up with a large number of options for help,
including a wiki, video tutorials, a ''Support`` page,
and a lot of input from the community.
%
Simply click ''Help`` at the top,
and select one of the options.
%
Alternatively, Googling for ''in Galaxy how do I ...``
followed by your problem is likely to bring up some great advice as well.
%
When in doubt,
reach out to someone that may be able to help you,
either directly or by suggesting good terms for your search.





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{iPlant} %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

The iPlant collaborative was started in 2008 by
the National Science Foundation to develop cyber infrastructure
for life science research.
%
It is led by researchers at U. Arizona,
the Texas Advanced Computing Center, Cold Spring Harbor Lab, and UNC Wilmington.
%
iPlant offers a set of platforms for next-gen sequence analysis,
from graphical user interfaces to packaged command line Linux options.
%
Originally developed for use on plant genomics,
the tools are not unique by study system,
and so this resource was opened to other species as well.
%
The three tools
described below
(DNA Subway,
Discovery Environment,
and
Atmosphere)
are linked by their use of the ``iRods Data Store,''
a repository for uploaded data,
which holds your own data
along with publicly available data.
%
%
For the DNA Subway and Discovery Environment,
the on-screen prompts,
and linked help,
combined with your knowledge from this workshop,
should get you well started.
%
For Atmosphere,
your Linux knowledge will serve you quite well.


To get access to these tools, go to
\url{http://www.iplantcollaborative.org/},
the main site describing the iPlant initiative.
%
Select ``User Portal'', then ``Register''
and follow the on-screen instructions.
%
In the future,
log-in through the same ``User Portal'' page.


\subsection{DNA Subway}

The simplest of the tools is the DNA Subway,
and the ''Green line`` allows very basic RNAseq analysis.
%
This tool's benefits are also its drawbacks.
%
It is a simple, and very polished,
point and click tool through a basic analysis,
particularly when using their sample data.
%
This means students don't need to learn,
or even be exposed to,
R or the Linux command line.
%
However, this also means that there is
little flexibility
and little interaction,
potentially limiting student engagement,
while ensuring they don't wander off into the weeds.
%
As of this writing (2014 June),
the Green Line is limited to four samples,
and only works with eleven model species genomes.
%
This ensures consistent results, 
but means that your organism of interest may not be available
and that the data you are collecting this summer may exceed these limits.
%
In short, this is a great tool for an introduction to the
steps of RNAseq analysis,
but is not designed for research.


\subsection{Discovery Environment}

The Discovery Environment,
on the other hand,
is much more similar to Galaxy.
%
The user interface is different,
as is the set of tools available.
%
However, 
many of the programs you may be interested in using will 
be available,
and you can use your own data (via the Data Store)
following simple on-screen prompts.
%
Like Galaxy and the DNA Subway,
this can ease the transition into bioinformatics for students,
though likely will not be able to take you all the way through
to your research goals.
%
The major benefit over Galaxy is that,
through its use of the data store,
it is easier to transfer the data to
a more complete system,
specifically Atmosphere.


\subsection{Atmosphere}

Atmosphere is, essentially,
a cloud-based tool to access 
pre-built and custom
Linux environments (instance) with various programs
already installed.
%
Launching an Atmosphere instance will start up a
Linux command line or graphical user environment
with very good connection to the Data Store,
easing file saving/loading problems.
%
The consistent environments made possible
by creating (or using) a specific instance,
and the connection to the Data Store,
will reduce some of the early hurdles to student use.
%
% Unfortunately,
% Atmosphere currently seems under-powered,
% and it is often crashing.
%
However, while using a created instance is simple,
it can be difficult to build one with exactly the tools you want for a class.
%
The set up can be tricky to get just right, 
and the limits on software space can be problematic
if the program you want has many dependencies.
%
For long processes, 
a separate instance may be required for each step
in the analysis.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Accelerating Comparative Genomics} %%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Accelerating Comparative Genomics (CoGe)
is another online tool with 
a click-able user interface.
%
CoGe is geared towards genomic comparisons (hence the name),
but has a few tools which may also be useful for RNAseq analysis.
%
CoGe also integrates with the Data Store,
which may make it an especially great tool
if you are also interested in using pieces of the iPlant collaborative.
%
I encourage you to look through their help for general information,
as well as to refer to the modules written by
Dr. Vincent Buonaccorsi for his GCAT-SEEK breakout session on
Eukaryotic Genomics: Comparative genomics,
for more information on what is possible in CoGe.


There is, however only one tool for RNAseq,
described in one of the CoGe youtube videos here:
\href{https://youtu.be/3fNyHGB02dM}{youtu.be/3fNyHGB02dM}.
%
While the tutorial takes only a few minutes,
please note that they are using an incredibly small data file.
%
In addition, there is no room for modifying parameters,
and the information it outputs (on gene models)
may not be what you are interested in.
%
As part of the CoGe approach to comparative genomics,
this tool is built for gene annotation,
and as such, 
has no support for differential expression.
%
However,
it may still be a nice tool to
demonstrate some of the basic concepts in short class time
or extend your genetic analyses.




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{David Functional Annotation Tool} %%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\label{sect:David}

Functional group analysis (described more fully in Chapter \ref{chap:GOanalysis}),
requires a fairly substantial amount of preparation work.
%
There are several online tools to ease running GO functional group analysis,
including within both iPlant and Galaxy.
%
However, these tools still require many of the same preparation steps,
such as obtaining GO annotations.
%
An alternative is to use a web-based tool specifically designed for GO analysis,
such as the David Functional Annotation Tool.


The David website (\url{http://david.abcc.ncifcrf.gov}),
allows users to input gene IDs from many model systems,
and it then uses available annotations,
without the user needing to find them.
%
Someone working with Arabidopsis can, for example,
just submit a list of DE genes
(based on whatever threshold you are using).
%
They then submit a background gene list,
which is most appropriately the genes known to be expressed in the sampled tissue
(rather than the DAVID default of all genes in the genome).
%
David will then supply a list of significantly over-represented GO terms
and allow for some further analysis.


Several options exist to modify the David output.
%
The user can, for example,
select to only analyze 
GO levels that are appropriate for the functions of interest.
%
This is most often not the most broad and basic levels.
%
Biological or Molecular Process levels 3-7 are often the most informative.
%
In the DAVID tool,
the P-value is adjusted using the Benjamini FDR correction by default,
but different corrections are available.


This tool still presents challenges to non-model species studies.
%
Because the tool only has access to model system GO annotations,
it won't be able to analyze a gene list from other species.
%
However, here, instead of having to run a full GO annotation
(as described in Chapter \ref{chap:GOanalysis}),
the user would submit the gene identifiers of the best blast hit.
%
David will then analyze those homolog gene identifiers
(e.g. Flybase or TAIR gene names)
in place of the actual gene names from non-model species.
%
The standard caution remains however,
that these annotations should be taken with caution,
as the function of a gene may have changed
over the evolutionary distance between your
organism and the model-species reference.


David does a fantastic job of outputting basic GO analysis information
that is well suited for use in a brief class discussion,
or when analyzing a model system for which the defaults work.
%
However, as with the other web-based tools we have encountered,
there is slightly less flexibility than when working in R
or other systems.
%
In addition, if you are generating gene lists in R already,
it may be easier to just call a variable name than to
copy and paste the results into a new tool and save them outside of R.



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Commercial Software} %%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Up until now,
all of the programs that I have described are free and open-source.
%
This means that they are free-as-in-beer (they cost nothing)
and free-as-in-speech (you can see all of the code,
and do what you want with it).
%
%
However, not all software falls into this category.
%
% Merge these two
There are a number of software packages available for a cost.
%
These systems generally have very clean, attractive, and intuitive
graphical user interfaces (GUIs)
that make working with them simple.
%
In addition, they generally package all of the tools you may want together;
giving you a single installation,
rather than the multitude we have used here.
%
If you have the money,
and the inclination,
such software can make the entry into bioinformatics more pleasant.


These systems come with downsides, including
lack of transparency,
lack of community support,
and cost.
%
First, because the software is proprietary,
you don't know exactly what it is doing with your data,
which can make interpreting the outcomes very difficult,
and makes troubleshooting nearly impossible in some cases.
%
Second, the proprietary nature means that there is,
generally,
far less community support for the software.
%
This limits the number of help posts you are likely to find,
and also means that new features aren't emerging from the field.
%
In contrast, new packages and software are constantly emerging
to extend open-source software to accomplish new things
(such as the R packages we used here).
%
Finally, these programs can be \emph{very} expensive.
%
Licenses (which last a limited time)
can run well into the thousands of dollars,
quickly reaching prohibitive levels for most labs.


That said, many of the users of these commercial programs
swear by them.
%
If you haven't noticed yet from the size of my soap box,
I am both too cheap and too devoted to open-source to have much 
experience with these tools.
%
However, below is an incomplete list of software that you may
be interested in pursuing.

\begin{itemize}
 \item Avidis NGS
 \item CLC Genomics Workbench
%  \item DNAnexus
 \item DNASTAR QSeq 
 \item Partek Genomics Suite
 \item OmicsOffice for NGS
 \item NextGENe
\end{itemize}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Further Reading} %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

For completeness, here is a list of open-source bioinformatics software:\\
\url{http://en.wikipedia.org/wiki/List\_of\_open-source\_bioinformatics\_software}
and a general list of RNAseq tools available,
including both open-source and commercial options,
sorted by step:
\url{http://en.wikipedia.org/wiki/List\_of\_RNA-Seq\_bioinformatics_tools}
% 
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% \section{Where to go for help} %%%%%%%%%%%%%%%%%%%%%%%%%%%
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% Each of these systems have help integrated with them.
% 
